<template>
  <v-app class= "grey lighten-2">
    <Navbar/>
    <v-main class="grey lighten-2" align="center">
      <!-- set to true for normal grpcClient -->
      <webSocketClient v-if="true" v-on:newPoint="addPoint($event)" />
      <PixiScatterPlot ref="pixiScatterPlot"/>
      <Counter ref="counter"/>
      <v-btn color="primary" text @click="resetPoints">Reset points</v-btn>
      <v-btn color="primary" text @click="addRandomPoints">Add random points</v-btn>
    </v-main>
  </v-app>
</template>

<script>
import Navbar from './components/Navbar';
import webSocketClient from './components/webSocketStreaming'
import PixiScatterPlot from './components/PixiScatterPlot';
import Counter from './components/counter';

const delay = time => new Promise(resolve => setTimeout(resolve, time));

export default {
  name: 'App',

  components: {
    Navbar,
    webSocketClient,
    PixiScatterPlot,
    Counter
  },

  data() {
    return {
      pointsCount: 0
    }
  },

  methods: {
    addPoint(point) {
      // simulate changing min/max
      // TODO: remove
      const factor = Math.floor(this.pointsCount / 25000) + 1;
      point["x"] *= factor;
      point["y"] *= factor;


      this.$refs.pixiScatterPlot.addPoint(point);

      this.pointsCount++;
      this.$refs.counter.setCounter(this.pointsCount);
    },

    resetPoints() {
      this.$refs.pixiScatterPlot.resetPoints();

      this.pointsCount = 0;
      this.$refs.counter.setCounter(this.pointsCount);
    },

    async addRandomPoints() {
      for (let i = 0; i < 100; i++) {
        const x = Math.floor(Math.random() * 100);
        const y = Math.floor(Math.random() * 100);
        this.addPoint({"id": i, "x": x, "y":y})
        await delay(0);
      }
    },
  }
};
</script>
